<?php

class Entity_Carerix_EmployeeLanguage {

    private $postValues = array();
    private $employeeLanguage = null;
    private static $count = 0;
    
    private $values = array(
        'language' => '',
        'read' => '',
        'write' => '',
        'speak' => '',
    );

    public function __construct($values, $employee) {
        $this->postValues = $values;
        $this->employeeLanguage = $employee;
    }
    
    public function getData() {
        /**
         * empty data
         */
        if(count($this->postValues) <= 0 && $this->employeeLanguage === null) {
            self::$count++;
            return $this->values;
        }
        
        /**
         * there are some post data. Post data has priority over carerix data
         */
        if(count($this->postValues) > 0) {
            
            foreach($this->values as $fieldName => &$value) {
                if(   isset($this->postValues[$fieldName])
                   && isset($this->postValues[$fieldName][self::$count])) {
                    $value = $this->postValues[$fieldName][self::$count];
                }
            }
            
            self::$count++;
            return $this->values;
        }
        
        /**
         * if it reached this point, there are no post data, carerix data has 
         * priority
         */
        if(   $this->employeeLanguage !== null 
           && isset($this->employeeLanguage[self::$count])) {
            
            /** @var Carerix_Api_Rest_Entity_CRWorkHistory ToDo */
            $language = $this->employeeLanguage[self::$count];
            foreach($this->values as $fieldName => &$value) {
                switch($fieldName) {
                    case 'language':
                        $node = $language->getToLanguage();
                        $value = '';
                        if($node) {
                            $value = $language->getToLanguage()->getId();   
                        }
                        break;
                    case 'read':
                        $node = $language->getToLanguageReadLevel();
                        $value = '';
                        if($node) {
                            $value = $language->getToLanguageReadLevel()->getId();   
                        }
                    break;
                    case 'write':
                        $node = $language->getToLanguageWriteLevel();
                        $value = '';
                        if($node) {
                            $value = $language->getToLanguageWriteLevel()->getId();   
                        }
                    break;
                    case 'speak':
                        $node = $language->getToLanguageSpeakLevel();
                        $value = '';
                        if($node) {
                            $value = $language->getToLanguageSpeakLevel()->getId();   
                        }
                    break;
                    default:
                        $methodName = 'get'.ucfirst($fieldName);
                        $value = $language->$methodName();
                        break;
                }
            }
            
            self::$count++;
            return $this->values;
        }
    }
}